routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'WelcomeController@index')
    ->name('welcome');

Route::get('/home', function () {
    return redirect('/');
});

Auth::routes();

/*
 * Ramais
*/
$router->group(['prefix' => '/admin', 'middleware' => 'auth'], function ($router) {
    $router->resource('/ramais', 'Admin\\BranchController', [
	    'as' => 'admin',
	])->parameters(['ramais' => 'branch']);

    $router->resource('/informativos', 'Admin\\InformativeController', [
	    'as' => 'admin',
	])->parameters(['informativos' => 'informative']);

    $router->resource('/links', 'Admin\\LinkController', [
	    'as' => 'admin',
	])->parameters(['links' => 'link']);

	$router->resource('/configuracoes', 'Admin\\SettingController', [
        'as' => 'admin',
	])->parameters(['configuracoes' => 'setting']);

    $router->resource('/usuarios', 'Admin\\UserController', [
        'as' => 'admin',
	])->parameters(['usuarios' => 'user'])
        ->only('index', 'edit', 'update');
});

/*
 * Ramais
*/
$router->group(['prefix' => '/ramais'], function ($router) {
    $router->get('/', 'BranchesController@index')
        ->name('branches.branch.index');
});

/*
 * Frequencias
*/
$router->group(['prefix' => '/frequencias'], function ($router) {
    $router->get('/', 'FrequencyController@index')
        ->name('frequencies.frequency.index')
        ->middleware('auth');

    $router->post('/', 'FrequencyController@store')
        ->name('frequencies.frequency.store')
        ->middleware('auth');
});

/*
 * Informativos
*/
$router->group(['prefix' => 'informativos'], function($router) {
    $router->get('/', 'InformativeController@index')
        ->name('informatives.informative.index')
        ->middleware('auth');
});


$router->group(['prefix'=> 'tickets'], function($router) {
    $router->get('/', 'TicketsController@index')
        ->name('tickets.ticket.index');

    $router->post('/', 'TicketsController@send')
        ->name('tickets.ticket.send')
        ->where('sector', '[0-9]+');

    $router->get('/ti', 'TicketsController@ti')
        ->name('tickets.ticket.ti');

    $router->get('/infra', 'TicketsController@infra')
        ->name('tickets.ticket.infra');

});

/*
Route::group(
[
    'prefix' => 'tickets',
], function () {

    Route::get('/', 'TicketsController@index')
      ->name('tickets.ticket.index');

    Route::get('/ti', 'TicketsController@ti')
      ->name('tickets.ticket.ti');

    Route::get('/infra', 'TicketsController@infra')
      ->name('tickets.ticket.infra');

    Route::post('/', 'TicketsController@send')
      ->name('tickets.ticket.send')
      ->where('sector', '[0-9]+');

});
*/

app/Models/Link.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Link extends Model
{
    /**
     * The database table used by the model.
     *
     * @var string
     */
    protected $table = 'links';

    /**
    * The database primary key value.
    *
    * @var string
    */
    protected $primaryKey = 'id';

    /**
     * Attributes that should be mass-assignable.
     *
     * @var array
     */
    protected $fillable = [
                  'link',
                  'description',
                  'clicks'
              ];

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = [];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [];

    /**
     * Get created_at in array format
     *
     * @param  string  $value
     * @return array
     */
    public function getCreatedAtAttribute($value)
    {
        return date('j/n/Y g:i A', strtotime($value));
    }

    /**
     * Get updated_at in array format
     *
     * @param  string  $value
     * @return array
     */
    public function getUpdatedAtAttribute($value)
    {
        return date('j/n/Y g:i A', strtotime($value));
    }
}

app/Http/Controllers/Admin/LinkController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Link;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class LinkController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $links = Link::orderBy('created_at', 'ASC')->get();
        return view('admin.links.index', compact('links'));
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.links.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = $this->validateData($request);

        if ($validator->fails()) {
			return back()
            	->withInput()
				->withErrors($validator->messages());
        }

        Link::create($request->all());
        return redirect()->route('admin.links.index')
            ->with('success_message', 'Link adicionado com sucesso.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function show(Link $link)
    {
        return view('admin.links.show', compact('link'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function edit(Link $link)
    {
        $link = Link::findOrFail($link->id);
        return view('admin.links.edit', compact('link'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Link $link)
    {
        $validator = $this->validateData($request);

        if ($validator->fails()) {
		    return back()
                ->withInput()
                ->withErrors($validator->messages());
        }

        $link->update($request->all());

        return redirect()->route('admin.links.index')
            ->with('success_message', 'Link atualizado com sucesso.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function destroy(Link $link)
    {
        $link->delete();
        return redirect()->route('admin.links.index')
            ->with('success_message', 'Link removido com sucesso.');
    }

	/**
     * Get the request's data from the request.
     *
     * @param Illuminate\Http\Request\Request $request
     * @return array
     */
    protected function validateData(Request $request)
    {
        $rules = [
            'link' => 'required|string|min:1|max:191',
            'description' => 'required|string|min:1|max:191',
        ];

        $validator = Validator::make($request->all(), $rules);

        return $validator;
    }
}

app/Http/Controllers/Api/Admin/LinkController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Link;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class LinkController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $links = Link::orderBy('created_at', 'ASC')->get();
        return view('admin.links.index', compact('links'));
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.links.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = $this->validateData($request);

        if ($validator->fails()) {
			return back()
            	->withInput()
				->withErrors($validator->messages());
        }

        Link::create($request->all());
        return redirect()->route('admin.links.index')
            ->with('success_message', 'Link adicionado com sucesso.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function show(Link $link)
    {
        return view('admin.links.show', compact('link'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function edit(Link $link)
    {
        $link = Link::findOrFail($link->id);
        return view('admin.links.edit', compact('link'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Link $link)
    {
        $validator = $this->validateData($request);

        if ($validator->fails()) {
		    return back()
                ->withInput()
                ->withErrors($validator->messages());
        }

        $link->update($request->all());

        return redirect()->route('admin.links.index')
            ->with('success_message', 'Link atualizado com sucesso.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function destroy(Link $link)
    {
        $link->delete();
        return redirect()->route('admin.links.index')
            ->with('success_message', 'Link removido com sucesso.');
    }

	/**
     * Get the request's data from the request.
     *
     * @param Illuminate\Http\Request\Request $request
     * @return array
     */
    protected function validateData(Request $request)
    {
        $rules = [
            'link' => 'required|string|min:1|max:191',
            'description' => 'required|string|min:1|max:191',
        ];

        $validator = Validator::make($request->all(), $rules);

        return $validator;
    }
}

app/Http/Controllers/Api/LinkController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\Link;
use Illuminate\Http\Request;

class LinkController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $links = Link::all();
        return response()->json($links);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function show(Link $link)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Link $link)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Link  $link
     * @return \Illuminate\Http\Response
     */
    public function destroy(Link $link)
    {
        //
    }
}

resources/views/admin/links/create.blade.php
@extends('layouts.modules')

@section('content')

<div class="section">
  <div class="container">
    <div class="columns is-centered">
      <div class="column is-half">
      <div class="box">
        <h2 class="title">Cadastrar novo link</h2>
        @if ($errors->any())
        <div class="notification">
          <h4 class="title">Verifique se o formulário está correto</h4>
          <ul>
            @foreach ($errors->all() as $error)
              <li>{{ $error }}</li>
            @endforeach
          </ul>
        </div>
        @endif

        <form method="POST" action="{{ route('admin.links.store') }}" accept-charset="UTF-8" id="create_link_form" name="create_link_form">
          {{ csrf_field() }}
          @include ('admin.links.form', ['link' => null])

          <div class="control">
            <a class="button button-default" href="javascript:history.back()">Voltar</a>
            <input class="button is-primary" type="submit" value="Adicionar">
          </div>
        </form>

      </div>
      </div>
    </div>
  </div>
</div>

@endsection

resources/views/admin/links/edit.blade.php
@extends('layouts.modules')

@section('content')

<div class="section">
  <div class="container">
    <div class="columns is-centered">
      <div class="column is-half">
      <div class="box">
        <h2 class="title">Editar link</h2>
        @if ($errors->any())
          <div class="notification">
            <h4 class="title">Verifique se o formulário está correto</h4>
            <ul>
              @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
              @endforeach
            </ul>
          </div>
        @endif

        <form method="POST" action="{{ route('admin.links.update', $link) }}" id="edit_link_form" name="edit_link_form" accept-charset="UTF-8">
          {{ csrf_field() }}
          <input name="_method" type="hidden" value="PUT">
          @include ('admin.links.form', ['link' => $link])

          <div class="control">
            <a class="button button-default" href="javascript:history.back()">Voltar</a>
            <input class="button is-primary" type="submit" value="Atualizar">
          </div>
        </form>

      </div>
      </div>
    </div>
  </div>
</div>

@endsection

resources/views/admin/links/form.blade.php
<div class="columns">
  <div class="column">

    <div class="field">
      <label class="label" for="link">Link</label>
      <div class="control">
        <input class="input {{ $errors->has('link') ? 'is-danger' : '' }}" name="link" type="text" id="link" value="{{ old('link', optional($link)->link) }}" minlength="1" maxlength="191" required="true" placeholder="Link completo (http://...)">
        <span class="help">Link no formato completo, http://.. ou https://..)</span>
        {!! $errors->first('sector', '<p class="is-small is-danger">:message</p>') !!}
      </div>
    </div>

    <div class="field">
      <label class="label" for="description">Descrição</label>
      <div class="control">
        <input class="input {{ $errors->has('description') ? 'is-danger' : '' }}" name="description" type="text" id="description" value="{{ old('description', optional($link)->description) }}" minlength="10" maxlength="50" required="true" placeholder="Descrição (exemplo: Suporte DGTI)">
        {!! $errors->first('sector', '<p class="is-small is-danger">:message</p>') !!}
      </div>
    </div>
  </div>
</div>

resources/views/admin/links/index.blade.php
@extends('layouts.modules')

@section('content')

<div class="section">
  <div class="container">
    <div class="">
      <div class="box">

        <div id="notification" class="notification is-success is-light is-hidden">
            {{ session('success_message') }}
        </div>

        <h2 class="title">Links</h2>
        <p><a class="button is-info" href="{{ route('admin.links.create') }}">Adicionar novo link</a></p>

        @if (count($links) == 0)
          <p class="uk-text-center">Nenhum link cadastrado</p>
        @else

        <table class="table table-striped is-fullwidth is-hoverable">
          <thead>
            <tr>
              <th>Link</th>
              <th>Descrição</th>
              <th>Ações</th>
            </tr>
          </thead>

          <tbody>
            @foreach ($links as $link)
            <tr>
              <td>{{ $link->link }}</td>
              <td>{{ $link->description }}</td>
              <td>
                <a href="{{ route('admin.links.edit', $link->id ) }}" class="button is-white is-text">
                  <span class="icon">
                    <i class="mdi mdi-pencil"></i>
                  </span>
                </a>
                <form id="link-form" class="is-pulled-left" name="deleteLinkForm" method="POST" action="{!! route('admin.links.destroy', $link) !!}" accept-charset="UTF-8">
                    <input name="_method" value="DELETE" type="hidden">
                    {{ csrf_field() }}
                    <button class="button is-white is-text" type="submit">
                        <span class="icon">
                            <i class="mdi mdi-delete"></i>
                        </span>
                    </button>
                </form>
              </td>
            </tr>
            @endforeach
          </tbody>
        </table>

        <a class="button button-default" href="javascript:history.back()">Voltar</a>
        @endif
      </div>
    </div>
  </div> <!-- container -->
</div> <!-- /section -->
@endsection

@section('jscontent')
  <script>
  @if(Session::has('success_message'))
    var notification = document.getElementById('notification');
    notification.classList.remove('is-hidden');
    setTimeout(function(){ notification.classList.add('is-hidden'); }, 5000);
  @endif
  </script>
@endsection